<?php
/*
	遊戲序號領取系統 (遊戲序號/文字類發佈) FOR Discuz! 7.0 NC 或 Discuz! 7.1
	整個程序由bencwk自行開發
	請尊重作者，嚴禁移除版權信息，請勿用於商業用途

	本文件中大部份都列有註解，各位可以依自己喜好進行調整或優化
*/
require_once './include/common.inc.php';

@include './forumdata/cache/plugin_gameacc.php';
$gameacc_setting = $_DPLUGIN['gameacc'][vars];
$good_names = $gameacc_setting[good_names]; //預設派發類型..例如:帳號、序號、道具等；在後台設定
$gameopen = $gameacc_setting[gameopen]; //插件前台開關，1是開，0是關；在後台設定
$gamerepeat = $gameacc_setting[gamerepeat]; //允許會員重覆申請，1是允許，0是不允許；在後台設定

$navigation = ' &raquo; <a href="gameacc.php">領取系統</a>';
$navtitle = '領取系統 - ';

if($adminid != '1' && $allowaccget != '1'){
	showmessage('group_nopermission', NULL, 'NOPERM'); //沒有領取權限
}

$gameadmin = ($adminid == '1') ? '1' :'';

if($action == 'main' || !$action){
	$action = 'main';
	$gamelist = array();
	$de_mark = array();
	$total = '0';
	$query = $db->query("SELECT * FROM `{$tablepre}gameacc` ORDER BY id DESC");
	while($game = $db->fetch_array($query)) {
		$gamelist[] = $game;
		$game[good_names] = $game[good_names] ? $game[good_names] : $good_names;
		if($allowaccfree != '1'){
			$de_mark = explode("|", $game[de_mark]);
			for($i = 1; $i <= 8; $i++) {
				if(($de_mark[$i] > 0) && $extcredits[$i]['title']){
					$de_list[$game[id]] .= $de_list[$game[id]] ? '、' : '';
					$de_list[$game[id]] .= $extcredits[$i]['title']." -$de_mark[$i]".$extcredits[$i]['unit'];
				}
			}

		}else{
			$de_list[$game[id]] = '閣下的用戶組擁有免費權限';
		}
		$total++;
	}
	if(($total == '0'  || $gameopen=='0') && $gameadmin != '1') 
		showmessage('暫時沒有任何項目供領取，請留意論壇公告');
	elseif($total == '0' && $gameadmin == '1') 
		showmessage('請先進入後台新增'.$good_names,'?action=admin&pages=add_game');
	
	include template('gameacc');

}elseif($action == 'output'){
	if($gameacc_setting[repeatseconds] != 0){
		session_start();
		$seconds = intval($gameacc_setting[repeatseconds]); //秒數
		if (isset($_SESSION["gameacc"])){
			if ($timestamp - $_SESSION["gameacc"] < $seconds){
				showmessage("請不要短時間內刷新，請返回");
			}else{
				$_SESSION["gameacc"] = time();
			}
		}else{
			$_SESSION["gameacc"] = $timestamp;
		}
	}

	$query = $db->query("SELECT * FROM `{$tablepre}gameacc` WHERE `id` = $gameid LIMIT 1");
	$game = $db->fetch_array($query);

	$good_names = $game[good_names] ? dhtmlspecialchars(preg_replace("/[\s\|\t\,\'\<\>]/", '', $game[good_names])) : $good_names;
	$game[name]= addslashes(dhtmlspecialchars($game[name].$game[good_names]));
	$acc2 = explode("\n", $game[acc]);
	//註冊天數檢查
	if($game[regdate] && $game[regdate] > 0) {
		if(!$discuz_uid)
			showmessage('對不起，你不符合領取的資格','?action=main');
		$query = $db->query("SELECT regdate FROM {$tablepre}members WHERE uid='$discuz_uid' LIMIT 1");
		$member = $db->fetch_array($query);
		$member['bemem'] = intval(($timestamp-$member['regdate'])/(3600*24));
		if($member['bemem'] < $game[regdate]){
			showmessage('對不起，你不符合領取的資格','?action=main');
		}
	}
	//多積分消費
	if($allowaccfree != '1'){
		$add_mysql = $de = '';
		$de_mark = explode("|", $game[de_mark]);
		for($i = 1; $i <= 8; $i++) {
			if($de_mark[$i] > 0  && $extcredits[$i]['title']){
				if($de_mark[$i] > $GLOBALS['extcredits'.$i]){
					showmessage('對不起，你不符合領取的資格','?action=main'); 
				}else{
					$add_mysql .= 'extcredits'.$i.'=extcredits'.$i.'-'.intval($de_mark[$i]).'';
					$de .= '<li><b>'.$extcredits[$i]['title'].'</b>：'.$GLOBALS['extcredits'.$i].' - '.$de_mark[$i].'</b> = <b>'.($GLOBALS['extcredits'.$i]-$de_mark[$i]).$extcredits[$game[de_extcredit]]['unit'].'</b>';
				}
			}
		}
		$de = ($de && $add_mysql) ? $de :'免費';
	}else{
		$de = '閣下的用戶組擁有免費權限';
	}
	//開始時限
	if($game[begin] && $game[begin] > $timestamp)
		showmessage('多謝閣下支持，此'.$good_names.'未開始派發','?action=main');
	//結束時限
	if(($game[expiration] && $game[expiration] < $timestamp) || $game[remain] >= $game[total] )
		showmessage('多謝閣下支持，此'.$good_names.'已經派發完畢，請繼續留意論壇動向!','?action=main');
	//重覆申請
	if($gamerepeat=='0' && $game[record] && strpos($game[record], '~'.$discuz_uid.'_') !== false) 
		showmessage('對不起，你不可以重覆申請','?action=main');

	//輸出結果
	/*顯示積分扣減情況*/ 
	$addrecord = '~'.$discuz_uid.'_'.$game[remain].'||';
	$newrecord = $game[record].$addrecord;
	$query = $db->query("UPDATE `{$tablepre}gameacc` SET `remain` = remain+1,`record`= '$newrecord' WHERE `id` = $gameid LIMIT 1");
	$outputinfo = $acc2[$game[remain]];
	/*pm*/ 
	if($discuz_uid){
		$pm_title = ''.$good_names.'領取完成';
		$pm_msg="這是由論壇系統自動發送的通知短消息。\n\n[b]以下您所領取的資料：[/b]\n\n[b]領取類型:[/b] $game[name]\n[b] $good_names :[/b] [quote] $outputinfo [/quote]\n\n\n\n此 $good_names 由 $bbname 提供\n";
		sendpm($discuz_uid, $pm_title, $pm_msg, 0);
		showmessage('積分扣減：'.$de.'<p>程序已經完成，閣下將會收到PM通知領取的'.$good_names.'。</p><div align="center"><a href="'.$indexname.'">點擊回到首頁</a></div>');
		}
                showmessage($msg.'<p>程序已經完成。</p><div align="center"><a href="'.$indexname.'">點擊回到首頁</a></div>');
}elseif($action == 'admin'){
	if($gameadmin != '1'){
		showmessage('後台只限管理員使用，請返回','gameacc.php');
	}
	$menu = '<a href="?action=admin&pages=add_game">新增遊戲</a><a href="?action=main">插件主頁</a>';
	if($pages == 'view' || !$pages){
		$pages = 'view';
		$list='';
		$gamelist = array();
		$query = $db->query("SELECT * FROM `{$tablepre}gameacc` ORDER BY id ASC");
		while($game = $db->fetch_array($query)) {
			$gamelist[] = $game;
			$game[good_names] = $game[good_names] ? $game[good_names] : $good_names;
			$detail = ''; //顯示狀態
			if($game[expiration] && $game[expiration] < $timestamp) {
				$detail=' <span class="lighttxt">已過期</span>';
			}else if($game[begin] && $game[begin] > $timestamp){
				$detail=' <span class="lighttxt">未開始派發</span>';
			}else if($game[total] > 0 && $game[remain] >= $game[total]){
				$detail=' <span class="lighttxt">派發完畢</span>';
			}else if($game[total] == 0){
				$detail=' <span class="bold">未完成設定</span>';
			}else if($game[remain] == '0'){
				$detail=' <span class="lighttxt">尚未有人領取</span>';
			}else{
				$detail=' <span class="lighttxt">派發中</span>';
			}
			$list .= '<tr><td>'.$game[id];
			$list .= '</td><td>'.$game[name];
			$list .= '</td><td>'.$detail;
			$list .= '</td><td>'.$game[good_names];
			$list .= '</td><td>'.$game[info];
			$list .= '</td><td>'.'<a href="?action=admin&amp;pages=edit_game&amp;gameid='.$game[id].'">[修改遊戲]</a> <a href="?action=admin&amp;pages=edit_acc&amp;gameid='.$game[id].'">[編輯'.$good_names.']</a> <a href="?action=admin&amp;pages=view_record&amp;gameid='.$game[id].'">[派發情況]</a> <a href="?action=admin&amp;pages=del_game&amp;gameid='.$game[id].'">[移除遊戲]</a>';
			$list .= '</td></tr>';
		}

		include template('gameacc');

	}elseif($pages == 'edit_game'){
		if(!$submit){
			$query = $db->query("SELECT * FROM `{$tablepre}gameacc` WHERE `id` = $gameid LIMIT 1");
			while($game = $db->fetch_array($query)) {
				$gamelist[] = $game;
				$good_names = $game[good_names] ? $game[good_names] : $good_names;
				$acc = $game[acc];
				$name = htmlspecialchars($game[name]);
				$gameurl = $game[gameurl];
				$url = $game[url];
				$info = $game[info];
				$logo = $game[logo];
				$de_mark = explode("|", $game[de_mark]);
				$total = $game[total];
				if($game[expiration] && $game[expiration] < $timestamp) {
					$expiration1='已過期';
				}
                                $expiration = $game[expiration] ? gmdate("$dateformat", $game[expiration] + $timeoffset * 3600) : '';
                                $begin = $game[begin] ? gmdate("$dateformat", $game[begin] + $timeoffset * 3600) : '';
				$regdate = $game[regdate];
				//$markselect = array(strval((float)$game[de_extcredit]) => 'selected="selected"');
			}
			$table="<tr align=\"center\">";
			for($i = 1; $i <= 8; $i++) {
				if($i % 5 == '0') $table.= "</tr><tr align=\"center\">";
				$table.= "<td width=\"50\">".$extcredits[$i]['title']."<br />extcredits".$i."</td>".
					"<td><input type=\"text\" size=\"5\" name=\"de_credit[]\" value=\"".$de_mark[$i]."\">".$extcredits[$i]['unit']."</td>";
			}
			if($total <= 0){
				showmessage("請先新增序號","?action=admin&amp;pages=edit_acc&amp;gameid=$gameid");
			}
			include template('gameacc');
			exit;

		}else{
			if(!$name || !$logo || !$info || !total || !$_POST[good_names] || count($de_credit)!='8'){
				showmessage("你未輸入所有必填欄位，請返回");
			}
			$de_mark='';
			foreach($de_credit as $de_credit) {
				$de_mark .= ($de_credit && intval($de_credit)>0) ? '|'.intval($de_credit) : '|0';
			}
			
			if($expiration && (strtotime($expiration) === -1 || strtotime($expiration) === FALSE || strtotime($expiration) < $timestamp))
				showmessage('結束派發日期輸入錯誤，日期格式 YYYY-MM-DD及不可設為今天或以前，請返回修改');
			if($begin && (strtotime($begin) === -1 || strtotime($begin) === FALSE))
				showmessage('開始派發日期輸入錯誤，日期格式 YYYY-MM-DD，請返回修改');
			if(($begin && $expiration) && (strtotime($begin)>strtotime($expiration) || strtotime($begin)==strtotime($expiration)))
				showmessage('結束派發日期須設定在開始派發日期之後，請返回修改');
			$expiration = $expiration ? strtotime($expiration) : '';
			$begin = $begin ? strtotime($begin) : '';

			$query = $db->query("UPDATE `{$tablepre}gameacc` SET `name` = '$name',`good_names` = '$_POST[good_names]',`gameurl` = '$gameurl',`url` = '$url',`logo` = '$logo',`info` = '$info',`de_mark` = '$de_mark',`expiration` = '$expiration',`begin` = '$begin',`regdate` = '$regdate' WHERE `id` =$gameid LIMIT 1 ");
			showmessage('完成','?action=admin&pages=view');

		}

	}elseif($pages == 'edit_acc'){
		if(!$gameid) showmessage('請從正確入口進入','gameacc.php');
		if(!$submit){
			$gamelist = array();
			$query = $db->query("SELECT id,acc,name FROM `{$tablepre}gameacc` WHERE `id` = $gameid LIMIT 1");
			while($game = $db->fetch_array($query)) {
				$gamelist[] = $game;
				$acc = $game[acc];
				$name = $game[name];
			}
			include template('gameacc');
			exit;

		}else{
			if(!$acc){
				$gamelist = array();
				$query = $db->query("SELECT id,acc,name FROM `{$tablepre}gameacc` WHERE `id` = $gameid LIMIT 1");
				while($game = $db->fetch_array($query)) {
					$gamelist[] = $game;
					$acc = $game[acc];
					$name = $game[name];
				}
				showmessage('請輸入所有必填欄位');
			}

			$acc2 = explode("\n", $acc);
			$acc_num = count($acc2);

			$gamelist = array();
			$query = $db->query("SELECT id,total,remain FROM `{$tablepre}gameacc` WHERE `id` = $gameid LIMIT 1");
				while($game = $db->fetch_array($query)) {
					$gamelist[] = $game;
					$add = $acc_num-$game[total];
				}

			if($add > '0'){
				$query = $db->query("UPDATE `{$tablepre}gameacc` SET `acc` = '$acc',`total` = '$acc_num' WHERE `id` =$gameid LIMIT 1 ");
				showmessage('完成設定'.$acc_num.'個'.$good_names.'(增加了'.$add.'個'.$good_names.')','?action=admin&amp;pages=view');
			}elseif($add != '0'){
				showmessage('開始派發後請勿刪去任何一行序號，否則會令系統出錯，你的動作已被禁止','?action=admin&amp;pages=view');
			}else{
				$query = $db->query("UPDATE `{$tablepre}gameacc` SET `acc` = '$acc',`total` = '$acc_num' WHERE `id` =$gameid LIMIT 1 ");
				showmessage('完成設定'.$acc_num.'個'.$good_names.'','?action=admin&pages=view');
			}

		}

	}elseif($pages == 'del_game'){
		if(!$gameid) showmessage('請從正確入口進入','gameacc.php');
		if(!$submit){
			showmessage('你確定要移除這個遊戲嗎？這項操作不可恢復！<br /><br /><a href="?action=admin&amp;pages=del_game&amp;submit=1&amp;gameid='.$gameid.'"><b>按此確認刪除</b></a><br /><br /><a href="gameacc.php?action=admin">按此回到管理頁面</a>');

		}else{
			$query = $db->query("DELETE FROM `{$tablepre}gameacc` WHERE `id` = '$gameid' LIMIT 1");
			showmessage('完成','?action=admin&pages=view');
		}

	}elseif($pages == 'add_game'){
		if(!$submit){
			$table="<tr align=\"center\">";
			for($i = 1; $i <= 8; $i++) {
				if($i % 5 == '0') $table.= "</tr><tr align=\"center\">";
				$table.= "<td width=\"50\">".$extcredits[$i]['title']."<br />extcredits".$i."</td>".
					"<td><input type=\"text\" size=\"5\" name=\"de_credit[]\" value=\"0\">".$extcredits[$i]['unit']."</td>";
			}
			include template('gameacc');
			exit;
		}else{
			if(!$name || !$logo || !$info || !total || !$_POST[good_names] || count($de_credit)!='8'){
				showmessage("你未輸入所有必填欄位，請返回");
			}
			$de_mark='';
			foreach($de_credit as $de_credit) {
				$de_mark .= ($de_credit && intval($de_credit)>0) ? '|'.intval($de_credit) : '|0';
			}

			$name = htmlspecialchars($name);

			if($expiration && (strtotime($expiration) === -1 || strtotime($expiration) === FALSE || strtotime($expiration) < $timestamp))
				showmessage('結束派發日期輸入錯誤，日期格式 YYYY-MM-DD及不可設為今天或以前，請返回修改');
			if($begin && (strtotime($begin) === -1 || strtotime($begin) === FALSE))
				showmessage('開始派發日期輸入錯誤，日期格式 YYYY-MM-DD，請返回修改');
			if(($begin && $expiration) &&  (strtotime($begin) > strtotime($expiration) || strtotime($begin) == strtotime($expiration)))
				showmessage('結束派發日期須設定在開始派發日期之後，請返回修改');

			$expiration = $expiration ? strtotime($expiration) : '';
			$begin = $begin ? strtotime($begin) : '';

			$query = $db->query("INSERT INTO `{$tablepre}gameacc` ( `id`, `name`, `good_names`, `logo`, `info`, `de_mark`, `total`, `remain`, `gameurl`, `url`, `expiration`, `begin`, `regdate` ) VALUES (NULL , '$name', '$_POST[good_names]', '$logo', '$info', '$de_mark', '$total', '0', '$gameurl', '$url', '$expiration', '$begin', '$regdate')");
			$gameid = $db->insert_id();
			showmessage('已經新增遊戲，現在將到新增'.$good_names.'的步驟','?action=admin&amp;pages=edit_acc&amp;gameid='.$gameid);
		}
	}elseif($pages == 'view_record'){
		if(!$gameid) showmessage('請從正確入口進入','gameacc.php');
		$table=$uids='';
		$i='0';
		/*讀取遊戲資料*/
		$query = $db->query("SELECT id,good_names,acc,total,remain,record,expiration FROM `{$tablepre}gameacc` WHERE `id` = $gameid LIMIT 1");
		$game = $db->fetch_array($query);
		$good_names = $game[good_names] ? $game[good_names] : $good_names;
		if(!$game[record]) showmessage('暫時未有任何會員領取啊','?action=admin');

		$recordb=explode('||', $game[record]);
		$acc2 = explode("\n", $game[acc]);
		$remain=$game[remain];
		$remain2=$game[remain]+1;

		/*分析已領取會員的uid*/
		foreach($recordb as $recordnow) {
			$recordc=explode('_', $recordnow);
			$recordd[]=substr($recordc[0], 1);
			if(substr($recordc[0], 1) != ''){
				if($recordc[0])$uids.=','.substr($recordc[0], 1);
			}

		}
		/*讀取用戶名稱*/
		$uidss = array();
		$uidquery = $db->query("SELECT uid, username FROM {$tablepre}members WHERE uid IN (".substr($uids, 1).") ORDER BY uid ASC");
		while($uidlist = $db->fetch_array($uidquery)) {
			$uidss[$uidlist['uid']] = $uidlist['username'];
		}
		foreach($recordd as $recordd2) {
			if($uidss[$recordd2]){
				$table .= "<tr><td width=\"50%\"><a href=\"viewpro.php?uid=".$recordd2."\">".$uidss[$recordd2]."</a></td><td>".$acc2[$i]."</td></tr>";
			}else{
				$table .= "<tr><td width=\"50%\">遊客</td><td>".$acc2[$i]."</td></tr>";
			}
			$i++;
		}

		include template('gameacc');

	}else{	
		showmessage('undefined_action', NULL, 'HALTED');
	}

}else{	
	showmessage('undefined_action', NULL, 'HALTED');
}


?>